############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub Common::NXTime::getSecondsSinceEpoch{package Common::NXTime;no warnings;(my $seconds
=libnxh::NXGetTime ());return ($seconds);}sub 
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch{package Common::NXTime;no 
warnings;(my $buffer=("\x3a" x (0x110d+ 1876-0x1839)));my (@arr);my (@result);(my $retval
=libnxh::NXSecondsAndMicrosecondsSinceEpoch ($buffer));if (($retval!=(-
(0x0aa8+ 7062-0x263d)))){(@arr=split ( /:/ ,$buffer,(0x1238+ 685-0x14e5)));(
@result=splice (@arr,(0x1e17+ 679-0x20be),(0x20b0+ 1329-0x25df)));return (
@result);}else{(my $errorNumber=libnxh::NXGetError ());(my $errorString=
libnxh::NXGetErrorString ());syswrite (STDERR,
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x20\x77\x69\x74\x68\x20\x6d\x69\x63\x72\x6f\x73\x65\x63\x6f\x6e\x64\x20\x70\x72\x65\x63\x69\x73\x69\x6f\x6e\x2e\x0a"
);syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getMillisecondsSinceEpoch{package Common::NXTime;no warnings
;(my ($seconds,$microseconds)=getSecondsAndMicrosecondsSinceEpoch ());(my $milliseconds
=int ((($seconds *(0x05f3+ 3050-0x0df5))+($microseconds/(0x1df5+ 1191-0x1eb4))))
);return ($milliseconds);}sub Common::NXTime::getLocalTime{package 
Common::NXTime;no warnings;my (@arr);my (@result);(my $buffer=("\x3a" x 
(0x1535+ 4607-0x270c)));(my $retval=libnxh::NXLocalTime ($buffer));if (($retval
!=(-(0x1200+ 3707-0x207a)))){(@arr=split ( /:/ ,$buffer,(0x0c73+ 6772-0x26e7)));
(@result=splice (@arr,(0x1a7c+ 1654-0x20f2),(0x0628+ 6813-0x20bc)));return (
@result);}else{(my $errorNumber=libnxh::NXGetError ());(my $errorString=
libnxh::NXGetErrorString ());syswrite (STDERR,
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x2e\x0a"
);syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getLocalTimeFromTimestamp{package Common::NXTime;no warnings
;(my $stamp=shift (@_));my (@arr);my (@result);(my $buffer=("\x3a" x 
(0x0826+ 7118-0x23cc)));(my $retval=libnxh::NXLocalTimeFromTimestamp ($stamp,
$buffer));if (($retval!=(-(0x1b17+ 2338-0x2438)))){(@arr=split ( /:/ ,$buffer,
(0x0cc9+ 3260-0x1985)));(@result=splice (@arr,(0x1394+ 831-0x16d3),
(0x06f8+ 5332-0x1bc3)));return (@result);}else{(my $errorNumber=
libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());syswrite (
STDERR,((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x74\x69\x6d\x65\x2e\x20\x41\x72\x67\x75\x6d\x65\x6e\x74\x20\x69\x73\x20"
.$stamp)."\x2e\x0a"));syswrite (STDERR,((((
"\x4e\x58\x3e\x20\x35\x39\x36\x20\x45\x72\x72\x6f\x72\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errorNumber)."\x2c\x20\x27").$errorString)."\x27\x2e\x0a"));main::nxexit ();}}
sub Common::NXTime::getDateString{package Common::NXTime;no warnings;(my $string
=libnxh::NXLocalTimeAsString ());return ($string);}sub 
Common::NXTime::getTimestamp{package Common::NXTime;no warnings;(my ($sec,
$microsec)=getSecondsAndMicrosecondsSinceEpoch ());(my (@time)=
getLocalTimeFromTimestamp ($sec));(my $milisec=sprintf ("\x25\x30\x36\x64",
$microsec));($milisec=((substr ($milisec,(0x07a5+ 6902-0x229b),
(0x050c+ 3390-0x1247))."\x2e").substr ($milisec,(0x08d6+ 976-0x0ca3))));(my $Timestamp
=((((((sprintf ("\x25\x30\x32\x64",$time[(0x09e1+ 285-0x0afc)])."\x3a").sprintf 
("\x25\x30\x32\x64",$time[(0x0434+ 4447-0x1592)]))."\x3a").sprintf (
"\x25\x30\x32\x64",$time[(0x0340+ 4956-0x169c)]))."\x3a").sprintf ($milisec)));
return ($Timestamp);}sub Common::NXTime::getTimestampOnlyMicroseconds{package 
Common::NXTime;no warnings;(my ($sec,$microsec)=
getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf ("\x25\x30\x36\x64"
,$microsec));($milisec=((substr ($milisec,(0x2500+ 106-0x256a),
(0x1296+ 4611-0x2496))."\x2e").substr ($milisec,(0x119f+ 1082-0x15d6))));(my $Timestamp
=sprintf ($milisec));return ($Timestamp);}sub Common::NXTime::__getTimeMs{
package Common::NXTime;no warnings;(my ($sec,$microsec)=
getSecondsAndMicrosecondsSinceEpoch ());(my (@time)=getLocalTimeFromTimestamp (
$sec));(my $milisec=sprintf ("\x25\x30\x36\x64",$microsec));($milisec=(substr (
$milisec,(0x011c+ 9195-0x2507),(0x025d+ 8289-0x22bb)).substr ($milisec,
(0x0e70+ 3285-0x1b42))));return ($milisec,@time);}sub Common::NXTime::getTimeMs{
package Common::NXTime;no warnings;(my ($milisec,@time)=__getTimeMs ());(my $TimeMs
=((((sprintf ("\x25\x30\x32\x64",$time[(0x0c46+ 6216-0x248c)]).sprintf (
"\x25\x30\x32\x64",$time[(0x1059+ 2707-0x1aeb)])).sprintf ("\x25\x30\x32\x64",
$time[(0x0eef+ 1422-0x147d)]))."\x2e").sprintf ($milisec)));return ($TimeMs);}
sub Common::NXTime::getLoggerTimeline{package Common::NXTime;no warnings;(my (
$milisec,@time)=__getTimeMs ());($milisec=((substr ($milisec,
(0x07df+ 4193-0x1840),(0x07c1+ 4593-0x19af))."\x2e").substr ($milisec,
(0x069c+ 5391-0x1ba8))));(my $Timeline=(sprintf (
"\x25\x30\x34\x64\x2d\x25\x30\x32\x64\x2d\x25\x30\x32\x64\x20\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x20"
,(1900+$time[(0x0ac8+ 4357-0x1bc8)]),((0x1342+ 3403-0x208c)+$time[
(0x12a6+ 4801-0x2563)]),$time[(0x1d36+ 367-0x1ea2)],$time[(0x0e78+ 4772-0x211a)]
,$time[(0x132c+ 3146-0x1f75)],$time[(0x0a8b+ 5625-0x2084)]).$milisec));return (
$Timeline);}sub Common::NXTime::getLoggerTimelineOnlyMicroseconds{package 
Common::NXTime;no warnings;(my ($milisec,@time)=__getTimeMs ());($milisec=((
substr ($milisec,(0x1cd2+ 1254-0x21b8),(0x11dd+ 5105-0x25cb))."\x2e").substr (
$milisec,(0x0568+ 7494-0x22ab))));(my $Timeline=sprintf ($milisec));return (
$Timeline);}sub 
Common::NXTime::convertLocalTimeFromTimestampToHumanReadableString{package 
Common::NXTime;no warnings;(my $timestamp=shift (@_));(my (@time)=
getLocalTimeFromTimestamp ($timestamp));(my $timeString=sprintf (
"\x25\x30\x34\x64\x2d\x25\x30\x32\x64\x2d\x25\x30\x32\x64\x20\x25\x30\x32\x64\x3a\x25\x30\x32\x64\x3a\x25\x30\x32\x64"
,((0x0c6c+ 2128-0x0d50)+$time[(0x143b+ 2035-0x1c29)]),($time[
(0x0acf+ 6446-0x23f9)]+(0x0df6+ 1605-0x143a)),$time[(0x004d+ 1223-0x0511)],$time
[(0x0831+ 2233-0x10e8)],$time[(0x0c58+ 5670-0x227d)],$time[(0x14c8+ 2114-0x1d0a)
]));return ($timeString);}sub Common::NXTime::getDateTimeForFileName{package 
Common::NXTime;no warnings;(my $dateTime=getLoggerTimeline ());($dateTime=~ s/ [^ ]*$// )
;($dateTime=~ s/-/./gm );($dateTime=~ s/:/./gm );($dateTime=~ s/ /-/gm );return 
($dateTime);}sub Common::NXTime::getSecondsInWeek{package Common::NXTime;no 
warnings;return (604800);}sub Common::NXTime::convertSecondsToDaysRounded{
package Common::NXTime;no warnings;(my $seconds=shift (@_));(my $days=($seconds/
86400));($days=(int ($days)+(0x0135+ 5718-0x178a)));return ($days);}package 
Common::NXTime;no warnings;"\x3f\x3f\x3f";
