############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXLogrotate;no warnings;($__timeoutForFileReleasedCheck=
(0x03e1+ 5672-0x19fa));($__sleepTimeBetweenFileReleaseChecks=0.2);(
$__checkLogrotateDelay=(0x0603+ 7821-0x210c));($__lastCheckLogrotate=
(0x0eb7+ 3743-0x1d56));($__nxhtdErrorLogPath=(""));($__forcedRotate=
(0x0ad8+ 4389-0x1bfd));($__forcedRotateDateTime=(""));((
%__ref_forcedRotateParameters)=());((%threadHandles)=());sub 
__rotateTillOriginalFile{(my $type=shift (@_));(my $rotatedName=shift (@_));(my $rotationDir
=NXLogrotateDB::getDestination ($type));(my $maxRotation=
NXLogrotateDB::getRotate ($type));(my $prevRotatedFile=((($rotationDir.
$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2e")).($maxRotation+
(0x0658+ 7886-0x2525))));if (NXLogrotateDB::isCompressSet ($type)){(
$prevRotatedFile=($prevRotatedFile."\x2e\x67\x7a"));}for ((my $i=$maxRotation);(
$i>(0x00f2+ 9354-0x257c));(--$i)){(my $curRotatedFile=((($rotationDir.
$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2e")).$i));if (
NXLogrotateDB::isCompressSet ($type)){($curRotatedFile=($curRotatedFile.
"\x2e\x67\x7a"));}if (Common::NXFile::fileExists ($curRotatedFile)){($result=
Common::NXFile::renameFile ($curRotatedFile,$prevRotatedFile));if (($result==
(0x1569+ 1068-0x1995))){NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x52\x65\x6e\x61\x6d\x65\x46\x69\x6c\x65",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$curRotatedFile,$prevRotatedFile)
;return ((0x1c2c+ 2155-0x2497));}}($prevRotatedFile=$curRotatedFile);}return (
(0x0378+ 149-0x040c));}sub __copyTruncate{(my $type=shift (@_));(my $path=shift 
(@_));(my $rotatedName=shift (@_));(my $destFilePath=
__getRotatedLogFilePathByLogType ($type,$rotatedName));(my $result=__copyLogFile
 ($path,$destFilePath));if (($result==(0x0b52+ 6973-0x268f))){return (
(0x0e2f+ 4064-0x1e0f));}return (__truncateFile ($path));}sub __removeExpiredLogs
{(my $type=shift (@_));(my $rotatedName=shift (@_));(my $rotationDir=
NXLogrotateDB::getDestination ($type));(my $maxRotation=NXLogrotateDB::getRotate
 ($type));(my $fileToRemove=((($rotationDir.$GLOBAL::DIRECTORY_SLASH).(
$rotatedName."\x2e")).($maxRotation+(0x1029+ 4655-0x2257))));if (
NXLogrotateDB::isCompressSet ($type)){($fileToRemove=($fileToRemove.
"\x2e\x67\x7a"));}if (Common::NXFile::fileExists ($fileToRemove)){return (
Common::NXFile::removeFile ($fileToRemove));}return ((0x02df+ 2571-0x0ce9));}sub
 forcedRotate{(my $ref_parameters=shift (@_));(my $result=
__handleForcedRotateParameters ($ref_parameters));if (($result==
(0x0b50+ 3692-0x19bc))){return ((0x1329+ 4176-0x2379));}if (($$ref_parameters{
"\x74\x79\x70\x65"}and (not (isLogTypeSupported ($$ref_parameters{
"\x74\x79\x70\x65"}))))){(my (@supportedTypes)=getAllSupportedLogrotateLogTypes 
());NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x54\x79\x70\x65\x4e\x6f\x74\x53\x75\x70\x70\x6f\x72\x74\x65\x64"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$$ref_parameters{
"\x74\x79\x70\x65"},join ($",@supportedTypes));return ((0x125c+ 4533-0x2411));}(my $dateTime
=Common::NXTime::getDateTimeForFileName ());__setForcedRotateDateTime ($dateTime
);__setForcedRotate ();return (rotate ($$ref_parameters{"\x74\x79\x70\x65"}));}
sub rotate{(my $type=(shift (@_)||("")));Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x65\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x2e"
);NXMsg::send_response (
"\x69\x43\x4d\x44\x53\x74\x61\x72\x74\x69\x6e\x67\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65");if (($type ne (""))){
__rotateByLogType ($type);}else{rotateAllLogFiles ();}Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x68\x61\x73\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x2e"
);}sub rotateAllLogFiles{main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");(my (
@availableTypes)=());if (__isForcedRotate ()){(@availableTypes=
getAllSupportedLogrotateLogTypes ());}else{(@availableTypes=
NXLogrotateDB::getLogTypes ());}foreach my $availableType (@availableTypes){if (
__shouldSkipMultiTypeLogrotateForType ($availableType)){next;}__rotateByLogType 
($availableType);}}sub __rotateByLogType{(my $type=shift (@_));Logger::debug (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x65\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x2e"));if (__isNotForcedRotate ()){main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");if (
NXLogrotateDB::isNotLogrotateExist ($type)){Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").
"\x4c\x6f\x67\x20\x74\x79\x70\x65\x20\x69\x73\x20\x6e\x6f\x74\x20\x65\x6e\x61\x62\x6c\x65\x64\x20\x66\x6f\x72\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x2e"
));NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x6f\x65\x73\x4e\x6f\x74\x45\x78\x69\x73\x74"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42",$type);NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);return (
(0x0f3c+ 4607-0x213b));}}($result=__rotateFilesByLogType ($type));if (($result==
(0x1d87+ 2177-0x2608))){Logger::error (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e"));NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);}else{Logger::debug (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type).
"\x27\x20\x68\x61\x73\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x2e"
));NXMsg::send_response (
"\x69\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x69\x6e\x69\x73\x68\x65\x64"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);}return ($result);}sub 
__getUserLogFilePathsByType{(my $type=shift (@_));(my $ref_filePaths=shift (@_))
;(my (@filePaths)=());(my (%users)=
NXUsersManager::userListIncludingInternalDMUsers ());foreach my $user (keys (
%users)){if (NXUsersManager::isDMUser ($user)){($user=
NXUsersManager::getRealDMUsername ($user));}(my $fileName=__getFilenameByLogType
 ($type));(my $path=((Common::NXPaths::getNxDirectoryInUserHomeDirectory ($user)
.$GLOBAL::DIRECTORY_SLASH).$fileName));(my $rotatedName=($fileName.("\x2d".$user
)));($$ref_filePaths{$rotatedName}=$path);}}sub 
__getSpecialUserLogFilePathByType{(my $type=shift (@_));(my $ref_filePaths=shift
 (@_));(my $fileName=__getFilenameByLogType ($type));(my $path=((
Common::NXPaths::getSpecialUsersLogFolderPath ().$GLOBAL::DIRECTORY_SLASH).
$fileName));($$ref_filePaths{$fileName}=$path);}sub __getFilePathsByLogType{(my $type
=shift (@_));(my (%filePaths)=());if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){if (($GLOBAL::CommonLogDirectory ne 
(""))){(my $fileName=__getFilenameByLogType ($type));(my $rotateFileName=(
$fileName."\x2d\x63\x6f\x6d\x6d\x6f\x6e"));($filePaths{$rotateFileName}=((
$GLOBAL::CommonLogDirectory.$GLOBAL::DIRECTORY_SLASH).$fileName));}else{
__getUserLogFilePathsByType ($type,(\%filePaths));
__getSpecialUserLogFilePathByType ($type,(\%filePaths));}}else{(my $fileName=
__getFilenameByLogType ($type));($filePaths{$fileName}=__getFilePathByLogType (
$type));}return (%filePaths);}sub __rotateFilesByLogType{(my $type=shift (@_));(my $ref_filePaths
=shift (@_));(my $silent=(shift (@_)||(0x062d+ 1865-0x0d76)));(my (%filePaths)=
());if (__isNotForcedRotate ()){((%filePaths)=%$ref_filePaths);}else{((
%filePaths)=__getFilePathsByLogType ($type));}(my $filesCount=
(0x146b+ 3072-0x206b));(my $noExistPath=(""));(my $result=(0x0064+ 2192-0x08f3))
;foreach my $rotatedName (keys (%filePaths)){(my $path=$filePaths{$rotatedName})
;if ((not (Common::NXFile::fileExists ($path)))){($noExistPath=$path);next;}(++
$filesCount);($result=__rotateWithCopytruncate ($type,$path,$rotatedName));if ((
$result!=(0x0337+ 2108-0x0b73))){($result=__postRotate ($type,$rotatedName,
$silent));}}if (($filesCount==(0x0a0f+ 765-0x0d0c))){if ((scalar (@filePaths)>
(0x0552+ 1842-0x0c83))){Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").
"\x4e\x6f\x20\x6c\x6f\x67\x20\x66\x69\x6c\x65\x73\x20\x66\x6f\x75\x6e\x64\x2e"))
;}else{Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").((
"\x4c\x6f\x67\x20\x66\x69\x6c\x65\x20\x27".$path).
"\x27\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e")));if ((
$silent==(0x1902+ 2127-0x2151))){Common::NXMsg::error (
"\x65\x46\x69\x6c\x65\x4e\x6f\x74\x45\x78\x69\x73\x74",$noExistPath);}}if ((
$silent==(0x00bd+ 4967-0x1424))){NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$noExistPath);}return (
(0x1428+ 1922-0x1baa));}return ($result);}sub __postRotate{(my $type=shift (@_))
;(my $rotatedName=shift (@_));(my $silent=shift (@_));if (((__isForcedRotate ()
and __isForcedRotateCompress ())or ((not (__isForcedRotate ()))and 
NXLogrotateDB::isCompressSet ($type)))){(my $rotatedFile=
__getRotatedLogFilePathByLogType ($type,$rotatedName));($result=__compressFile (
$rotatedFile,$silent));if (($result==(0x025c+ 6967-0x1d93))){return (
(0x0116+ 4171-0x1161));}Common::NXFile::removeFile ($rotatedFile);}return (
(0x144d+ 3785-0x2315));}sub __rotateWithCopytruncate{(my $type=shift (@_));(my $path
=shift (@_));(my $rotatedName=shift (@_));if (__isNotForcedRotate ()){(my $result
=__rotateTillOriginalFile ($type,$rotatedName));__removeExpiredLogs ($type,
$rotatedName);if (($result==(0x08e1+ 1499-0x0ebc))){return (
(0x02d6+ 1217-0x0797));}}return (__copyTruncate ($type,$path,$rotatedName));}sub
 __getRotatedLogFilePathByLogType{(my $type=shift (@_));(my $rotatedName=shift (
@_));if (__isNotForcedRotate ()){(my $destination=NXLogrotateDB::getDestination 
($type));return ((($destination.$GLOBAL::DIRECTORY_SLASH).($rotatedName.
"\x2e\x31")));}else{(my $destination=__getForcedRotateDestination ());return (((
($destination.$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2d")).
__getForcedRotateDateTime ()));}}sub __compressFile{(my $logFilePath=shift (@_))
;(my $silent=shift (@_));(my $compressedFile=($logFilePath."\x2e\x67\x7a"));(my $result
=Common::NXFile::compressFile ($logFilePath,$compressedFile));if (($result!=
(0x067b+ 2746-0x1134))){if (($silent==(0x201d+ 1332-0x2551))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6d\x70\x72\x65\x73\x73\x46\x69\x6c\x65"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$logFilePath);}return (
(0x19f6+ 955-0x1db1));}else{if (($silent==(0x03f4+ 8381-0x24b1))){
NXMsg::send_response (
"\x69\x43\x4d\x44\x43\x6f\x6d\x70\x72\x65\x73\x73\x65\x64\x46\x69\x6c\x65",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$compressedFile);}
__correctRotatedFileOwnershipAndPermissions ($compressedFile);return (
(0x0873+ 4936-0x1bba));}}sub isTimeForCheckLogrotate{(my $currentTime=
Common::NXTime::getSecondsSinceEpoch ());(my $delay=$__checkLogrotateDelay);if (
(($__lastCheckLogrotate+$delay)<$currentTime)){return ((0x10e8+ 494-0x12d5));}
return ((0x001c+ 6811-0x1ab7));}sub checkLogrotateAndHandleIfNeeded{
Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x73\x63\x68\x65\x64\x75\x6c\x65\x64\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x63\x68\x65\x63\x6b\x20\x66\x6f\x72\x20\x61\x6c\x6c\x20\x66\x69\x6c\x65\x73\x2e"
);($__lastCheckLogrotate=Common::NXTime::getSecondsSinceEpoch ());(my (
@typesToRotate)=());main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42");NXLogrotateDB::reload ()
;(my (@logTypes)=NXLogrotateDB::getLogTypes ());foreach my $type (@logTypes){(my $size
=NXLogrotateDB::getSizeInBytes ($type));(my $minsize=
NXLogrotateDB::getMinsizeInBytes ($type));(my $isTimeToRotate=
NXLogrotateDB::isTimeToRotate ($type));(my (%filePaths)=__getFilePathsByLogType 
($type));foreach my $fileName (keys (%filePaths)){(my $filePath=$filePaths{
$fileName});(my $fileSize=Common::NXCore::NXFileSize ($filePath));if (($size and
 ($size<=$fileSize))){return (__runLogrotateCommand ());}if ($isTimeToRotate){if
 (((not ($minsize))or ($minsize<$fileSize))){return (__runLogrotateCommand ());}
}}}}sub __runLogrotateCommand{(my (@command)=($GLOBAL::CommandNXexec,
$GLOBAL::SCRIPT_NXLOGROTATE));(my (@options)=
"\x72\x75\x6e\x20\x69\x6e\x20\x62\x67");main::nxRunCommand ((\@command),(
\@options));Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x6c\x6f\x67\x72\x6f\x74\x61\x74\x65\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x72\x75\x6e\x2e"
);}sub automaticRotate{(my (%typesToRotate)=());main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42");NXLogrotateDB::reload ()
;(my (@logTypes)=NXLogrotateDB::getLogTypes ());foreach my $type (@logTypes){(my $size
=NXLogrotateDB::getSizeInBytes ($type));(my $minsize=
NXLogrotateDB::getMinsizeInBytes ($type));(my $isTimeToRotate=
NXLogrotateDB::isTimeToRotate ($type));(my (%filePaths)=__getFilePathsByLogType 
($type));(my (%pathsToRotate)=());if (__shouldSkipMultiTypeLogrotateForType (
$type)){next;}foreach my $fileName (keys (%filePaths)){(my $filePath=$filePaths{
$fileName});(my $fileSize=Common::NXCore::NXFileSize ($filePath));if (($size and
 ($size<=$fileSize))){($pathsToRotate{$fileName}=$filePath);($typesToRotate{
$type}=(\%pathsToRotate));next;}if ($isTimeToRotate){if (((not ($minsize))or (
$minsize<$fileSize))){($pathsToRotate{$fileName}=$filePath);($typesToRotate{
$type}=(\%pathsToRotate));next;}}}}(my $silent=(0x0e14+ 2227-0x16c6));foreach my $type
 (keys (%typesToRotate)){__rotateFilesByLogType ($type,$typesToRotate{$type},
$silent);NXLogrotateDB::updateLastRotateTime ($type);}}sub 
__getFilePathByLogType{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return (
Common::NXPaths::getNXServerLogPath ());}elsif (($type eq 
Logger::getLogrotateLogTypeNxdLog ())){return (NXPaths::getNxdLog ());}elsif ((
$type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
NXPaths::getNxwebclientLog ());}elsif (($type eq 
Logger::getLogrotateLogTypeNxhtdErrorLog ())){if (($__nxhtdErrorLogPath eq (""))
){($__nxhtdErrorLogPath=NXTools::getNxhtdErrorLogPath ());}return (
$__nxhtdErrorLogPath);}elsif (($type eq Logger::getLogrotateLogTypeNxserviceLog 
())){return (NXPaths::getNxserviceLog ());}else{return ((""));}}sub 
__getFilenameByLogType{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67");}elsif (($type eq 
Logger::getLogrotateLogTypeNxdLog ())){return ("\x6e\x78\x64\x2e\x6c\x6f\x67");}
elsif (($type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
"\x6e\x78\x77\x65\x62\x72\x75\x6e\x6e\x65\x72\x2e\x6c\x6f\x67");}elsif (($type 
eq Logger::getLogrotateLogTypeNxhtdErrorLog ())){return (
"\x6e\x78\x68\x74\x64\x2e\x6c\x6f\x67");}elsif (($type eq 
Logger::getLogrotateLogTypeNxserviceLog ())){return (
"\x6e\x78\x73\x65\x72\x76\x69\x63\x65\x2e\x6c\x6f\x67");}else{return ((""));}}
sub isLogTypeSupported{(my $type=shift (@_));(my (@supportedTypes)=
getAllSupportedLogrotateLogTypes ());foreach my $supportedType (@supportedTypes)
{if (($supportedType eq $type)){return ((0x1954+ 1563-0x1f6e));}}return (
(0x0176+ 3183-0x0de5));}sub getAllSupportedLogrotateLogTypes{(my (@types)=());
push (@types,Logger::getLogrotateLogTypeNxserverLog ());push (@types,
Logger::getLogrotateLogTypeNxdLog ());if (NXLicense::isHttpdSupportFeature ()){
push (@types,Logger::getLogrotateLogTypeNwebclientLog ());push (@types,
Logger::getLogrotateLogTypeNxhtdErrorLog ());}return (@types);}sub 
__isTypeNxserverLog{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return ((0x21d6+ 978-0x25a7));}
return ((0x14f8+ 1185-0x1999));}sub __isTypeNxwebclientLog{(my $type=shift (@_))
;if (($type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
(0x1439+ 3594-0x2242));}return ((0x093d+ 6204-0x2179));}sub __truncateFile{(my $filePath
=shift (@_));(my $handle=main::nxopen ($filePath,($NXBits::O_WRONLY+
$NXBits::O_TRUNC)));if (defined ($handle)){main::nxclose ($handle);return (
(0x1dd2+ 243-0x1ec4));}return ((0x0c98+ 3686-0x1afe));}sub __copyLogFile{(my $filePath
=shift (@_));(my $destFilePath=shift (@_));(my ($return,$error)=
Common::NXCore::copyFile ($filePath,$destFilePath));if (($error ne (""))){return
 ((0x02ca+ 5192-0x1712));}__correctRotatedFileOwnershipAndPermissions (
$destFilePath);return ((0x0591+ 2696-0x1018));}sub 
__correctRotatedFileOwnershipAndPermissions{(my $file=shift (@_));
Common::NXFile::setPermissionsReadWriteForNX ($file);if (
main::effectiveUserIsAdministrator ()){
Common::NXFile::setOwnershipForUserAndGroupNX ($file);}return (
(0x0bff+ 3958-0x1b74));}sub __setForcedRotateDateTime{($__forcedRotateDateTime=
shift (@_));}sub __getForcedRotateDateTime{return ($__forcedRotateDateTime);}sub
 __setForcedRotate{($__forcedRotate=(0x0054+ 2804-0x0b47));}sub __isForcedRotate
{return ($__forcedRotate);}sub __getForcedRotateDestination{return (
$$__ref_forcedRotateParameters{"\x64\x65\x73\x74\x69\x6e\x61\x74\x69\x6f\x6e"});
}sub __isForcedRotateCompress{if (($$__ref_forcedRotateParameters{
"\x63\x6f\x6d\x70\x72\x65\x73\x73"}eq "\x6e\x6f")){return ((0x0d96+ 4132-0x1dba)
);}else{return ((0x1065+ 4081-0x2055));}}sub __isNotForcedRotate{return ((!
__isForcedRotate ()));}sub __handleForcedRotateParameters{(my $ref_parameters=
shift (@_));($__ref_forcedRotateParameters=$ref_parameters);main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");(my $procedure
="\x66\x6f\x72\x63\x65\x64\x52\x6f\x74\x61\x74\x65");return (
NXLogrotateDB::handleDestinationAndCompressParameters ($ref_parameters,
$procedure));}sub __shouldSkipMultiTypeLogrotateForType{(my $type=shift (@_));
return ((0x06ac+ 4638-0x18ca));}NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x53\x74\x61\x72\x74\x69\x6e\x67\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65"
,(0x0509+ 166-0x022b));NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x69\x6e\x69\x73\x68\x65\x64"
,(0x0b44+ 7548-0x253c));NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x43\x6f\x6d\x70\x72\x65\x73\x73\x65\x64\x46\x69\x6c\x65",
(0x1771+ 2634-0x1e37));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
(0x1784+ 690-0x1842));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x46\x69\x6c\x65\x49\x73\x42\x65\x69\x6e\x67\x55\x73\x65\x64",
(0x048a+ 4218-0x1310));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6d\x70\x72\x65\x73\x73\x46\x69\x6c\x65"
,(0x1cbb+ 1506-0x20a9));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x54\x79\x70\x65\x4e\x6f\x74\x53\x75\x70\x70\x6f\x72\x74\x65\x64"
,(0x16f5+ 352-0x1661));"\x3f\x3f\x3f";
