############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXLicense;no warnings;(my $virtualSessionSupport=(0x151a+ 4560-0x26ea));
(my $physicalSessionSupport=(0x05a4+ 1015-0x099b));(my $foreignSessionSupport=
(0x16d3+ 1023-0x1ad2));(my $customFreeSubscriptionMessage=(0x1201+ 2885-0x1d46))
;($licenseFormat="\x34");sub isPhysicalSessionSupportEnabled{return (
$physicalSessionSupport);}sub isVirtualSessionSupportEnabled{return (
$virtualSessionSupport);}sub isForeignSessionSupportEnabled{return (
$foreignSessionSupport);}sub isVirtualSessionSupportDisabled{return ((!
isVirtualSessionSupportEnabled ()));}sub isCustomFreeSubscriptionMessage{return 
($customFreeSubscriptionMessage);}sub enablePhysicalSessionSupport{(
$physicalSessionSupport=(0x0d89+ 4564-0x1f5c));}sub enableVirtualSessionSupport{
($virtualSessionSupport=(0x00f0+ 3646-0x0f2d));}sub enableForeignSessionSupport{
($foreignSessionSupport=(0x0499+  83-0x04eb));}sub 
enableCustomFreeSubscriptionMessage{($customFreeSubscriptionMessage=
(0x0bd3+ 4967-0x1f39));}sub chk_license{(my $subscription_mode=(shift (@_)||("")
));(my $selected_server_id=(shift (@_)||"\x30"));(my (@licenses)=());if ((
$subscription_mode ne (""))){($subscription_mode=(0x09ab+ 3131-0x15e5));}else{(
$subscription_mode=(0x1ad6+ 2638-0x2524));}(my (@licenseFile)=
load_license_from_file ());(my (@licencje)=convertToArray (@licenseFile));undef 
(@licenseFile);(my (@parsed_licenses)=convertArrayToLicArray (@licencje));if (($#parsed_licenses
==(-(0x07c4+ 4565-0x1998)))){Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);main::nxexit ((0x0a57+ 242-0x0b48));}(my $num=(-(0x0524+ 6959-0x2052)));
foreach my $lic (@parsed_licenses){(++$num);($lic=verify_entry ($lic));if ((
$selected_server_id ne "\x30")){if ((defined ($$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"})and ($$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}eq $selected_server_id))){if ((
$subscription_mode==(0x1079+ 3404-0x1dc4))){show_lic ($lic);}return (
(0x01ef+ 3352-0x0f07));}else{next;}}if (defined ($$lic{"\x65\x72\x72\x6f\x72"}))
{if (($subscription_mode==(0x0ae4+ 3642-0x191d))){show_lic ($lic);next;}else{if 
(($num eq$#parsed_licenses)){if (Common::NXMsg::check_msg ($$lic{
"\x65\x72\x72\x6f\x72"})){Common::NXMsg::error ($$lic{"\x65\x72\x72\x6f\x72"});}
main::nxexit ((0x1f7f+ 1550-0x258c));}next;}}if (defined ($$lic{
"\x50\x72\x6f\x64\x75\x63\x74"})){($GLOBAL::PRODUCT_NAME=$$lic{
"\x50\x72\x6f\x64\x75\x63\x74"});}if (($$lic{
"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}ne $$lic{
"\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x6b\x65\x79"})){
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);main::nxexit ((0x08e3+ 1115-0x0d3d));}if (($GLOBAL::SERVER_PRODUCT_KEY ne ("")
)){if (($$lic{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}eq 
$GLOBAL::SERVER_PRODUCT_KEY)){if (($$lic{
"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}ne $$lic{
"\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x6b\x65\x79"})){
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);main::nxexit ((0x0903+ 7433-0x260b));}else{set_product ($lic);return ($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"});}}}
elsif (($subscription_mode eq (0x0648+ 2595-0x106a))){show_lic ($lic);}elsif (((
$$lic{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}ne (""))and (
$selected_server_id eq ("")))){next;}else{set_product ($lic);return ($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"});}}if ((
defined ($selected_server_id)and ($selected_server_id ne "\x30"))){
Common::NXMsg::error (
"\x65\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x6f\x72\x53\x65\x72\x76\x65\x72\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
,$selected_server_id);Common::NXMsg::send_response ("\x65\x42\x79\x65");return (
(0x1dac+ 2371-0x26ef));}return ("\x4d\x69\x73\x73\x65\x64");}sub validate{(my $subscription_key
=(""));(my $subscription_type=(""));sub BEGIN{require Time::Local;do{
"\x54\x69\x6d\x65\x3a\x3a\x4c\x6f\x63\x61\x6c"->import};}(my $date=
Common::NXTime::getDateString ());chomp ($date);(my (@mon_list)=("\x4a\x61\x6e",
"\x46\x65\x62","\x4d\x61\x72","\x41\x70\x72","\x4d\x61\x79","\x4a\x75\x6e",
"\x4a\x75\x6c","\x41\x75\x67","\x53\x65\x70","\x4f\x63\x74","\x4e\x6f\x76",
"\x44\x65\x63"));(my (@day_list)=("\x53\x75\x6e","\x4d\x6f\x6e","\x54\x75\x65",
"\x57\x65\x64","\x54\x68\x75","\x46\x72\x69","\x53\x61\x74"));my ($sec,$min,
$hour,$mday,$mon,$year,$tz);if (($date=~ /^(... )(...) *(\d+) +(\d\d):(\d\d):(\d\d) (.*)(\d\d\d\d)/ )
){(($sec,$min,$hour,$mday,$mon,$year,$tz)=($6,$5,$4,$3,$2,$8,$7));($mon=~ s/Jan/00/i )
;($mon=~ s/Feb/01/i );($mon=~ s/Mar/02/i );($mon=~ s/Apr/03/i );($mon=~ s/May/04/i )
;($mon=~ s/Jun/05/i );($mon=~ s/Jul/06/i );($mon=~ s/Aug/07/i );($mon=~ s/Sep/08/i )
;($mon=~ s/Oct/09/i );($mon=~ s/Nov/10/i );($mon=~ s/Dec/11/i );if (($tz eq ("")
)){($tz="\x43\x45\x53\x54");($date=~ s/(\d\d\d\d)$/$tz $1/ );}}else{
Common::NXMsg::error (
"\x65\x44\x61\x74\x65\x49\x6e\x55\x6e\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x64\x46\x6f\x72\x6d\x61\x74"
,$date);main::nxexit ((0x1207+ 937-0x15af));}(my $Nts=Time::Local::timelocal (
$sec,$min,$hour,$mday,$mon,$year));($Nts+=2592000);(my ($sec,$min,$hour,$mday,
$mon,$year,$wday,$yday,$isdst)=Common::NXTime::getLocalTimeFromTimestamp ($Nts))
;($year+=(0x0ae0+ 975-0x0743));(my $expiryDate=((((((((((($day_list[$wday].
"\x20").$mon_list[$mon])."\x20").$mday)."\x20").sprintf ("\x25\x30\x32\x64",
$hour))."\x3a").sprintf ("\x25\x30\x32\x64",$min))."\x3a").sprintf (
"\x25\x30\x32\x64",$sec)).((("\x20".$tz)."\x20").$year)));(my $KEY_FD=
main::nxopen (($GLOBAL::PRODUCT_KEY_FILE."\x2e\x73\x61\x6d\x70\x6c\x65"),
$NXBits::O_RDONLY,(0x2046+ 1696-0x26e6)));if ((not (defined ($KEY_FD)))){
main::nxexit ((0x0a57+ 7138-0x2638));}(my $content=(""));while (main::nxreadLine
 ($KEY_FD,(\$_))){if (( /^----- Begin subscription data -----(\r*)$/ .. /^----- End subscription data -----(\r*)$/ )
){($content.=$_);}}main::nxclose ($KEY_FD);($content=~ s/\r+//gm );if (($content
=~ /^Subscription Type: +(.*)$/m )){($subscription_type=$1);}if ((not (($content
=~ /^Virtual Desktops: +(.*)$/m )))){($licenseFormat="\x33");}if ((
$subscription_type ne "\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e")){main::nxexit 
((0x051c+ 8165-0x2500));}if (($content=~ /^Subscription Key: +(.*)$/m )){(
$subscription_key=$1);}($content=~ s/^(Date: +).*$/$1/m );($content=~ s/^(Expiry: +).*$/$1/m )
;($content=~ s/^(Subscription Key: +).*$/$1/m );($content=~ s/----- Begin subscription data -----\n//m )
;($content=~ s/----- End subscription data -----\n*//m );($content=~ s/(^Date:                   )/$1$date/m )
;($content=~ s/(^Expiry:                 )/$1$expiryDate/m );my (
$c_subscription_key);(my $add_chr=substr (Common::NXCore::digestMd5Hex ($date),
(0x0d20+ 5520-0x22b0),(0x009c+ 3230-0x0d32)));if (($licenseFormat eq "\x33")){(
$c_subscription_key=Common::NXCore::digestMd5Hex (($content.
$GLOBAL::PRODUCT_KEY_SALT)));}else{($c_subscription_key=(
Common::NXCore::digestMd5Hex (($content.$GLOBAL::PRODUCT_KEY_SALT)).$add_chr));}
($content=~ s/(^Subscription Key:       )/$1$c_subscription_key/m );($KEY_FD=
main::nxopen (($GLOBAL::PRODUCT_KEY_FILE."\x2e\x73\x61\x6d\x70\x6c\x65"),((
$NXBits::O_WRONLY+$NXBits::O_TRUNC)+$NXBits::O_CREAT),(($NXBits::UserReadWrite+
$NXBits::GroupReadWrite)+$NXBits::OthersReadWrite)));if ((not (defined ($KEY_FD)
))){main::nxexit ((0x0107+ 8898-0x23c8));}main::nxwrite ($KEY_FD,((
"\x0a\x2d\x2d\x2d\x2d\x2d\x20\x42\x65\x67\x69\x6e\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x64\x61\x74\x61\x20\x2d\x2d\x2d\x2d\x2d\x0a"
.$content).
"\x2d\x2d\x2d\x2d\x2d\x20\x45\x6e\x64\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x64\x61\x74\x61\x20\x2d\x2d\x2d\x2d\x2d\x0a\x0a"
));main::nxclose ($KEY_FD);}sub serverLicExist{if (Common::NXFile::isExists (
$GLOBAL::NXSERVER_PRODUCT_KEY_FILE)){return ((0x02b9+ 6753-0x1d19));}else{return
 ((0x17e9+ 3105-0x240a));}}sub set_product{(my $lic=shift (@_));(
$GLOBAL::PRODUCT_ID=$$lic{
"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"});(
$GLOBAL::CONNECTIONS_LIMIT=$$lic{"\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73"}
);($$lic{"\x50\x72\x6f\x64\x75\x63\x74"}=~ s/NoMachine Portal Server/NoMachine Enterprise Terminal Server/ )
;($$lic{"\x50\x72\x6f\x64\x75\x63\x74"}=~ s/NoMachine Enterprise Server/NoMachine Enterprise Terminal Server/ )
;($GLOBAL::PRODUCT_NAME=$$lic{"\x50\x72\x6f\x64\x75\x63\x74"});if (
libnxh::NXIsValidAcronymId ($$lic{"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"})){
($GLOBAL::SUBSCRIPTION_ID=$$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"});
enablePhysicalSessionSupport ();if ((not (libnxh::NXIsEnterpriseDesktopNode (
$$lic{"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"})))){
enableVirtualSessionSupport ();enableForeignSessionSupport ();}if (
libnxh::NXIsNomachineFreeServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"})){
enableCustomFreeSubscriptionMessage ();}}else{Common::NXMsg::error (
"\x65\x47\x55\x49\x49\x6e\x76\x61\x6c\x69\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);Logger::error (
"\x54\x68\x65\x20\x6c\x69\x63\x65\x6e\x73\x65\x20\x69\x73\x20\x6e\x6f\x74\x20\x73\x75\x69\x74\x61\x62\x6c\x65\x20\x66\x6f\x72\x20\x74\x68\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x76\x65\x72\x73\x69\x6f\x6e\x2e\x20\x50\x6c\x65\x61\x73\x65\x20\x63\x6f\x6e\x74\x61\x63\x74\x20\x74\x68\x65"
);Logger::error (
"\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x53\x61\x6c\x65\x73\x20\x54\x65\x61\x6d\x20\x74\x6f\x20\x67\x65\x74\x20\x61\x20\x73\x75\x69\x74\x61\x62\x6c\x65\x20\x6c\x69\x63\x65\x6e\x73\x65\x2e"
);Logger::error (
"\x54\x68\x65\x20\x4e\x6f\x4d\x61\x63\x68\x69\x6e\x65\x20\x6e\x6f\x64\x65\x20\x63\x61\x6e\x6e\x6e\x6f\x74\x20\x70\x65\x72\x66\x6f\x72\x6d\x20\x74\x68\x65\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6f\x70\x65\x72\x61\x74\x69\x6f\x6e\x2e"
);main::nxexit ((0x0a5a+ 5523-0x1fed));}}sub 
setProductAndWelcomeStringBaseOnHardcodedID{(my $productId=
libnxh::NXTransGetEnvironment ("\x4e\x58\x50\x52\x4f\x44\x55\x43\x54"));if ((
$productId eq (""))){($productId=$ENV{"\x4e\x58\x50\x52\x4f\x44\x55\x43\x54"});}
(my $acronymId=libnxh::NXParseServerProductId ($productId));if (
libnxh::NXIsValidAcronymId ($acronymId)){enablePhysicalSessionSupport ();if ((
not (libnxh::NXIsEnterpriseDesktop ($acronymId)))){enableVirtualSessionSupport 
();enableForeignSessionSupport ();}if (libnxh::NXIsNomachineFreeServer (
$acronymId)){enableCustomFreeSubscriptionMessage ();}}($GLOBAL::PRODUCT_ID=
$productId);($GLOBAL::PRODUCT_NAME=libnxh::NXParseProductName ($productId));(
$GLOBAL::WELCOME_STR=(($GLOBAL::PRODUCT_NAME.
"\x20\x2d\x20\x56\x65\x72\x73\x69\x6f\x6e\x20").$GLOBAL::SOFTWARE_RELEASE));(
$GLOBAL::MESSAGES_FORMAT{$GLOBAL::MSG_WELCOME_STR}=$GLOBAL::WELCOME_STR);}sub 
show_lic{(my $lic=shift (@_));if (defined ($$lic{"\x65\x72\x72\x6f\x72"})){
Common::NXMsg::send_response ("\x69\x50\x72\x6f\x64\x75\x63\x74\x4b\x65\x79",
$$lic{"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"});if (
Common::NXMsg::check_msg ($$lic{"\x65\x72\x72\x6f\x72"})){Common::NXMsg::error (
$$lic{"\x65\x72\x72\x6f\x72"});}return;}if (($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"}eq 
"\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e")){Logger::warning (
Common::NXMsg::getBrandedMessage (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e"
,$$lic{"\x45\x78\x70\x69\x72\x79"}));Common::NXMsg::send_response (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e"
,$$lic{"\x45\x78\x70\x69\x72\x79"});return;}elsif (($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"}eq 
"\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e\x45\x78\x70\x69\x72\x65\x64")){
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x45\x76\x61\x6c\x75\x61\x74\x69\x6f\x6e\x45\x78\x70\x69\x72\x65\x64"
);return;}elsif ((($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}eq 
"\x4e\x6f\x6e\x65")and isCustomFreeSubscriptionMessage ())){
Common::NXMsg::send_response (
"\x77\x43\x6d\x64\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x46\x72\x65\x65"
);return;}elsif (((($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}eq 
"\x4e\x6f\x6e\x65")or ($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}eq 
"\x50\x61\x72\x74\x6e\x65\x72"))or ($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}eq 
"\x44\x65\x76\x65\x6c\x6f\x70\x65\x72"))){Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x55\x6e\x73\x75\x62\x73\x63\x72\x69\x62\x65\x64"
);return;}elsif (($$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"}eq 
"\x53\x74\x61\x6e\x64\x61\x72\x64\x45\x78\x70\x69\x72\x65\x64")){main::nxwrite (
main::nxgetSTDOUT (),main::subscriptionInfo ($$lic{
"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"},$$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"},$$lic{
"\x70\x65\x72\x69\x6f\x64"},$$lic{
"\x62\x75\x69\x6c\x64\x64\x61\x79\x5f\x66\x6f\x72\x6d\x61\x74\x65\x64"},$$lic{
"\x45\x78\x70\x69\x72\x79"}));Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x45\x78\x70\x69\x72\x65\x64"
);return;}Common::NXMsg::send_response (
"\x69\x50\x72\x6f\x64\x75\x63\x74\x4b\x65\x79",$$lic{
"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"});main::nxwrite (
main::nxgetSTDOUT (),main::subscriptionInfo ($$lic{
"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"},$$lic{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"},$$lic{
"\x70\x65\x72\x69\x6f\x64"},$$lic{
"\x62\x75\x69\x6c\x64\x64\x61\x79\x5f\x66\x6f\x72\x6d\x61\x74\x65\x64"},$$lic{
"\x45\x78\x70\x69\x72\x79"},"\x20\x20"));}sub verify_entry{(my $lic=shift (@_));my (
$sec,$min,$hour,$mday,$mon,$year);if (($$lic{"\x55\x73\x65\x72\x73"}=~ /nlimited$/ )
){($$lic{"\x55\x73\x65\x72\x73"}=(0x0f5a+ 5681-0x258b));}if (($$lic{
"\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73"}=~ /nlimited$/ )){($$lic{
"\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73"}=(0x0ec2+ 3383-0x1bf9));}($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}=libnxh::NXParseNodeProductId ($$lic{
"\x70\x72\x6f\x64\x75\x63\x74\x5f\x69\x64"}));if (((((((((((((not (
libnxh::NXIsTerminalServerNode ($$lic{"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"
})))and (not (libnxh::NXIsSmallBusinessServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseDesktopNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsQuickServerNode ($$lic{"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))
))and (not (libnxh::NXIsEnterpriseCloudServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsSmallBusinessTerminalServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseCloudServerClusterNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseTerminalServerClusterNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsSmallBusinessCloudServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseTerminalServerNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))and (not (
libnxh::NXIsEnterpriseTerminalServersNode ($$lic{
"\x61\x63\x72\x6f\x6e\x79\x6d\x5f\x69\x64"}))))){if (((not (defined ($$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"})))or ($$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}eq ("")))){Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);main::nxexit ((0x167c+ 3435-0x23e6));}}if (($$lic{
"\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x69\x64"}ne $GLOBAL::BUILD_PLATFORM)){
unless ((($GLOBAL::BUILD_PLATFORM eq "\x52")and (($$lic{
"\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x69\x64"}eq "\x4c")||($$lic{
"\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x69\x64"}eq "\x41")))){($$lic{
"\x65\x72\x72\x6f\x72"}=
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x50\x6c\x61\x74\x66\x6f\x72\x6d\x4e\x6f\x74\x4d\x61\x74\x63\x68"
);return ($lic);}}if (($$lic{"\x45\x78\x70\x69\x72\x79"}ne 
"\x55\x6e\x6c\x69\x6d\x69\x74\x65\x64")){if (($$lic{"\x45\x78\x70\x69\x72\x79"}
=~ /^(... )(...) *(\d+) +(\d\d):(\d\d):(\d\d) (.*) (\d\d\d\d)/ )){(($sec,$min,
$hour,$mday,$mon,$year)=($6,$5,$4,$3,$2,$8));($mon=month2digit ($mon));}elsif ((
$$lic{"\x45\x78\x70\x69\x72\x79"}=~ /^.*(\d\d\d\d)-(\d\d)-(\d\d)/ )){($year=$1);
($mon=$2);($mday=$3);}else{($$lic{"\x65\x72\x72\x6f\x72"}=
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x45\x78\x70\x69\x72\x79\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);return ($lic);}(my $expiry=(($year.sprintf ("\x25\x30\x32\x64",$mon)).sprintf 
("\x25\x30\x32\x64",$mday)));(my $expiry_timestamp=Time::Local::timelocal ($sec,
$min,$hour,$mday,($mon-(0x08a1+ 7477-0x25d5)),$year));my (@ltime);(@ltime=
Common::NXTime::getLocalTime ());(my $now=($ltime[(0x0bd4+ 864-0x0f2f)]+
(0x0e3c+ 1328-0x0c00)));($now=($now.sprintf ("\x25\x30\x32\x64",($ltime[
(0x1fd1+ 209-0x209e)]+(0x1215+ 3382-0x1f4a)))));($now=($now.sprintf (
"\x25\x30\x32\x64",$ltime[(0x1745+ 2297-0x203b)])));if (($$lic{
"\x44\x61\x74\x65"}=~ /^(... )(...) *(\d+) +(\d\d):(\d\d):(\d\d) (.*) (\d\d\d\d)/ )
){(($sec,$min,$hour,$mday,$mon,$year)=($6,$5,$4,$3,$2,$8));($mon=month2digit (
$mon));}elsif (($$lic{"\x44\x61\x74\x65"}=~ /^.*(\d\d\d\d)-(\d\d)-(\d\d)/ )){(
$year=$1);($mon=$2);($mday=$3);}else{($$lic{"\x65\x72\x72\x6f\x72"}=
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x44\x61\x74\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);return ($lic);}(my $date=(($year.sprintf ("\x25\x30\x32\x64",$mon)).sprintf (
"\x25\x30\x32\x64",$mday)));(my $date_timestamp=Time::Local::timelocal ($sec,
$min,$hour,$mday,($mon-(0x0f7f+ 856-0x12d6)),$year));(my $period=(
$expiry_timestamp-$date_timestamp));($period=($period/86400));if ((($period eq 
(0x1719+ 1637-0x1c11))or ($period eq (0x0ba6+ 4484-0x1bbc)))){($$lic{
"\x70\x65\x72\x69\x6f\x64"}="\x31\x20\x79\x65\x61\x72");}else{($$lic{
"\x70\x65\x72\x69\x6f\x64"}=(int ($period)."\x20\x64\x61\x79\x73"));}}else{(
$$lic{"\x70\x65\x72\x69\x6f\x64"}="\x55\x6e\x6c\x69\x6d\x69\x74\x65\x64");}if ((
$$lic{"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}ne $$lic{
"\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x6b\x65\x79"})){($$lic{
"\x65\x72\x72\x6f\x72"}=
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x56\x61\x6c\x69\x64"
);return ($lic);}if ((not (defined ($$lic{"\x62\x75\x69\x6c\x64\x64\x61\x79"})))
){(($$lic{"\x62\x75\x69\x6c\x64\x64\x61\x79\x5f\x66\x6f\x72\x6d\x61\x74\x65\x64"
},$$lic{"\x62\x75\x69\x6c\x64\x64\x61\x79"})=buildday_formated ());}return ($lic
);}sub month2digit{(my $mon=shift (@_));($mon=~ s/Jan/00/i );($mon=~ s/Feb/01/i )
;($mon=~ s/Mar/02/i );($mon=~ s/Apr/03/i );($mon=~ s/May/04/i );($mon=~ s/Jun/05/i )
;($mon=~ s/Jul/06/i );($mon=~ s/Aug/07/i );($mon=~ s/Sep/08/i );($mon=~ s/Oct/09/i )
;($mon=~ s/Nov/10/i );($mon=~ s/Dec/11/i );(++$mon);return ($mon);}sub 
take_product_id{(my $content=shift (@_));my ($product_id);if (($content=~ /^Product Id: +(.)(.*)$/m )
){($product_id=$2);}return ($product_id);}sub take_platform_id{(my $content=
shift (@_));my ($platform_id);if (($content=~ /^Product Id: +(.)(.*)$/m )){(
$platform_id=$1);}return ($platform_id);}sub take_field_from_license{(my $field=
shift (@_));(my $content=shift (@_));if (($content=~ /^$field: +(.*)$/m )){(my $value
=$1);return ($value);}return;}sub convertArrayToLicArray{(my (@licencje)=@_);(my (
@result)=());foreach my $entry (@licencje){my ($tmp);($$tmp{
"\x43\x75\x73\x74\x6f\x6d\x65\x72"}=take_field_from_license (
"\x43\x75\x73\x74\x6f\x6d\x65\x72",$entry));($$tmp{"\x44\x61\x74\x65"}=
take_field_from_license ("\x44\x61\x74\x65",$entry));($$tmp{
"\x50\x72\x6f\x64\x75\x63\x74"}=take_field_from_license (
"\x50\x72\x6f\x64\x75\x63\x74",$entry));($$tmp{
"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"}=
take_field_from_license ("\x50\x72\x6f\x64\x75\x63\x74\x20\x49\x64",$entry));(
$$tmp{"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x49\x64"}=
take_field_from_license (
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x49\x64",$entry));($$tmp{
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x54\x79\x70\x65"}=
take_field_from_license (
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x54\x79\x70\x65",$entry));
($$tmp{"\x45\x78\x70\x69\x72\x79"}=take_field_from_license (
"\x45\x78\x70\x69\x72\x61\x74\x69\x6f\x6e\x7c\x45\x78\x70\x69\x72\x79",$entry));
($$tmp{"\x55\x73\x65\x72\x73"}=take_field_from_license ("\x55\x73\x65\x72\x73",
$entry));($$tmp{"\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73"}=
take_field_from_license ("\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x73",$entry))
;($$tmp{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}=take_field_from_license (
"\x53\x65\x72\x76\x65\x72\x20\x4b\x65\x79",$entry));($$tmp{
"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"}=take_field_from_license (
"\x50\x72\x6f\x64\x75\x63\x74\x20\x4b\x65\x79",$entry));($$tmp{
"\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x5f\x6b\x65\x79"}=
take_field_from_license (
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x4b\x65\x79",$entry));(
$$tmp{"\x76\x69\x72\x74\x75\x61\x6c\x5f\x64\x65\x73\x6b\x74\x6f\x70\x73"}=
take_field_from_license (
"\x56\x69\x72\x74\x75\x61\x6c\x20\x44\x65\x73\x6b\x74\x6f\x70\x73",$entry));(
$$tmp{"\x70\x6c\x61\x74\x66\x6f\x72\x6d\x5f\x69\x64"}=take_platform_id ($entry))
;($$tmp{"\x70\x72\x6f\x64\x75\x63\x74\x5f\x69\x64"}=take_product_id ($entry));(
$$tmp{"\x6c\x69\x63\x65\x6e\x73\x65\x5f\x66\x69\x6c\x65"}=$entry);($$tmp{
"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}=
calculate_license_md5 ($entry));($$tmp{
"\x6c\x69\x63\x65\x6e\x73\x65\x5f\x76\x65\x72\x73\x69\x6f\x6e"}="\x34");if ((((
$$tmp{"\x63\x61\x6c\x63\x75\x6c\x61\x74\x65\x64\x5f\x6d\x64\x35"}ne (""))and (
$$tmp{"\x50\x72\x6f\x64\x75\x63\x74\x5f\x49\x64\x5f\x65\x78\x74"}ne ("")))and (
$$tmp{"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"}ne ("")))){push (@result,
$tmp);}}return (@result);}sub calculate_license_md5{(my $content=shift (@_));(my $date_formated
=(""));if (($content=~ /^Date: +(.*)$/m )){($date_formated=$1);}(my $add_chr=
substr (Common::NXCore::digestMd5Hex ($date_formated),(0x0ea0+ 1437-0x143d),
(0x02a5+ 7526-0x2003)));($content=~ s/^(Subscription Key: +).*$/$1/m );($content
=~ s/----- Begin subscription data -----\n//m );($content=~ s/----- End subscription data -----\n*//m )
;if (($content=~ /Virtual Desktops:/ )){return ((Common::NXCore::digestMd5Hex ((
$content.$GLOBAL::PRODUCT_KEY_SALT)).$add_chr));}else{return (
Common::NXCore::digestMd5Hex (($content.$GLOBAL::PRODUCT_KEY_SALT)));}}sub 
buildday_formated{(Common::NXCore::decodeDate ($GLOBAL::BUILD_DAY)=~ /(\d{4})(\d{2})(\d{2})/ )
;(my $buildday_timestamp=Time::Local::timelocal ((0x15b4+ 2706-0x2046),
(0x086c+ 6373-0x2151),(0x092a+ 344-0x0a76),$3,($2-(0x028c+ 1692-0x0927)),$1));my (
$wday,$yday,$isdst);(my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=
Common::NXTime::getLocalTimeFromTimestamp ($buildday_timestamp));($year+=
(0x0f26+ 3958-0x1730));(my (@mon_list)=("\x4a\x61\x6e","\x46\x65\x62",
"\x4d\x61\x72","\x41\x70\x72","\x4d\x61\x79","\x4a\x75\x6e","\x4a\x75\x6c",
"\x41\x75\x67","\x53\x65\x70","\x4f\x63\x74","\x4e\x6f\x76","\x44\x65\x63"));(my (
@day_list)=("\x53\x75\x6e","\x4d\x6f\x6e","\x54\x75\x65","\x57\x65\x64",
"\x54\x68\x75","\x46\x72\x69","\x53\x61\x74"));(my $buildday_formated=((((((((((
($day_list[$wday]."\x20").$mon_list[$mon])."\x20").$mday)."\x20").sprintf (
"\x25\x30\x32\x64",$hour))."\x3a").sprintf ("\x25\x30\x32\x64",$min))."\x3a").
sprintf ("\x25\x30\x32\x64",$sec)).("\x20\x43\x45\x54\x20".$year)));(my $buildday
=$year);($buildday=($buildday.sprintf ("\x25\x30\x32\x64",($mon+
(0x02b4+ 8112-0x2263)))));($buildday=($buildday.sprintf ("\x25\x30\x32\x64",
$mday)));return ($buildday_formated,$buildday);}sub convertToArray{(my (
@licenseFile)=@_);(my (@licencje)=());my ($tagON);my ($lic);(my $FoundLicense=
(0x0b2d+ 1737-0x11f6));foreach my $line (@licenseFile){if (($line=~ /^----- Begin subscription data -----(\r*)$/ )
){($lic=(""));($tagON=(0x0345+ 2569-0x0d4d));}if (($tagON==(0x05f1+ 4974-0x195e)
)){($lic.=($line."\x0a"));}if (($line=~ /^----- End subscription data -----(\r*)$/ )
){if (($lic ne (""))){push (@licencje,$lic);}($tagON=(0x0b50+ 4914-0x1e82));(
$lic=(""));}}return (@licencje);}sub load_license_from_file{Logger::debug (((
"\x52\x65\x61\x64\x69\x6e\x67\x20\x6c\x69\x63\x65\x6e\x73\x65\x20\x77\x69\x74\x68\x20\x65\x66\x66\x65\x63\x74\x69\x76\x65\x20\x75\x69\x64\x20\x27"
.$>)."\x27\x2e"));(my $mode=Common::NXCore::NXFileMode (
$GLOBAL::PRODUCT_KEY_FILE));if ((defined ($mode)and (($mode&
(0x258d+ 1747-0x1c61))ne (0x1bf2+ 214-0x1bc8)))){Logger::warning ((((
"\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x66\x69\x6c\x65\x20\x27".
$GLOBAL::PRODUCT_KEY_FILE).
"\x27\x20\x68\x61\x73\x20\x77\x72\x6f\x6e\x67\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x2e"
).
"\x20\x43\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x61\x72\x65\x20\x30\x34\x30\x30\x2e"
));}(my $content=(""));(my $FILE=main::nxopen ($GLOBAL::PRODUCT_KEY_FILE,
$NXBits::O_RDONLY,(0x0f07+ 4585-0x20f0),{"\x45\x41\x43\x43\x45\x53",
"\x73\x69\x6c\x65\x6e\x74"}));if ($FILE){while (main::nxreadLine ($FILE,(\$_))){
($content.=$_);}main::nxclose ($FILE);}else{if (($>eq (0x0d0c+ 665-0x0fa5))){(my $errorNumber
=libnxh::NXGetError ());(my $errorString=libnxh::NXGetErrorString ());
Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x61\x64\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$license)."\x27\x2e"));Logger::error (((((
"\x45\x72\x72\x6f\x72\x20\x69\x73\x20".$errorNumber)."\x20\x27").$errorString).
"\x27\x2e"));Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);main::nxexit ((0x15ec+ 3193-0x2265));}(my (@command)=$GLOBAL::CommandNXexec);
push (@command,"\x2d\x2d\x6e\x6f\x64\x65\x6c\x69\x63\x65\x6e\x73\x65");(my (
@params)=());push (@params,
"\x75\x73\x65\x20\x73\x63\x72\x69\x70\x74\x20\x74\x6f\x20\x6b\x69\x6c\x6c");(my (
$cmd_err,$cmd_out,$exit_value)=main::nxRunCommand ((\@command),(\@params)));if (
$exit_value){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x61\x63\x63\x65\x73\x73\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$GLOBAL::PRODUCT_KEY_FILE).
"\x27\x20\x74\x68\x72\x6f\x75\x67\x68\x20\x6e\x78\x65\x78\x65\x63\x2e"));
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);main::nxexit ((0x129f+  69-0x12e4));}else{Logger::debug (((((((
"\x28\x63\x6d\x64\x5f\x65\x72\x72\x2c\x20\x63\x6d\x64\x5f\x6f\x75\x74\x2c\x20\x65\x78\x69\x74\x5f\x76\x61\x6c\x75\x65\x29\x20\x28"
.$cmd_err)."\x2c\x20").$cmd_out)."\x2c\x20").$exit_value)."\x29\x2e"));($content
=$cmd_out);}}($content=Common::NXCore::extractLicenseBodyFromLicenseFile (
$content));return (split ( /\n/ ,$content,(0x07d2+ 841-0x0b1b)));}sub 
subscriptiondel{(my $subscriptionId=(shift (@_)||("")));my ($content);(my (
@licenseFile)=load_license_from_file ());(my (@licencje)=convertToArray (
@licenseFile));(my (@parsed_licenses)=convertArrayToLicArray (@licencje));(my $flag_found_subscription
=(0x0d92+ 3116-0x19be));(my $tmpLicFile=($GLOBAL::PRODUCT_KEY_FILE.
"\x2e\x74\x6d\x70"));(my $FH=main::nxopen ($tmpLicFile,$NXBits::O_WRONLY,
(0x1afb+ 2778-0x25d5)));if ((not (defined ($FH)))){(my $errorString=
libnxh::NXGetErrorString ());Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x50\x72\x6f\x64\x75\x63\x74\x4b\x65\x79"
,$tmpLicFile,$errorString);return;}foreach my $lic (@parsed_licenses){if (($$lic
{"\x70\x72\x6f\x64\x75\x63\x74\x5f\x6b\x65\x79"}ne $subscriptionId)){
main::nxwrite ($FH,$$lic{"\x63\x6f\x6e\x74\x65\x6e\x74"});}else{(
$flag_found_subscription=(0x2285+ 991-0x2663));}}main::nxclose ($FH);if ((
$flag_found_subscription==(0x0214+ 8086-0x21aa))){Common::NXMsg::error (
"\x65\x4e\x6f\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x41\x73\x73\x6f\x63\x69\x61\x74\x65\x64"
,$subscriptionId);unlink ($tmpLicFile);return;}(my (@command)=(
"\x2f\x62\x69\x6e\x2f\x63\x70",$tmpLicFile,$GLOBAL::PRODUCT_KEY_FILE));(my (@opt
)=());(my ($stderr,$stdout,$result_status)=run_command ((\@command),(\@opt)));if
 (($result_status==(0x11c3+ 595-0x1416))){Common::NXMsg::send_response (
"\x69\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x44\x65\x6c\x65\x74\x65\x64"
);}else{Common::NXMsg::error (
"\x65\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x43\x61\x6e\x6e\x6f\x74\x42\x65\x44\x65\x6c\x65\x74\x65\x64"
,$stderr);}return;}sub subscriptionadd{(my $sfile=(shift (@_)||("")));my (
$content);if (($sfile eq (""))){Common::NXMsg::error (
"\x65\x4e\x6f\x50\x61\x74\x68\x54\x6f\x4c\x69\x63\x65\x6e\x73\x65\x46\x69\x6c\x65"
);Common::NXMsg::error (
"\x65\x41\x64\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65"
);return ((0x0c2a+ 4623-0x1e39));}if ((not (Common::NXFile::fileExists ($sfile))
)){Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x46\x69\x6c\x65",$sfile);
Common::NXMsg::error ("\x65\x46\x69\x6c\x65\x4e\x6f\x74\x45\x78\x69\x73\x74",
$sfile);return ((0x130c+ 5027-0x26af));}(my $KEY_FD=main::nxopen ($sfile,
$NXBits::O_RDONLY,(0x09d9+ 4776-0x1c81)));if ((not (defined ($KEY_FD)))){(my $error
=libnxh::NXGetError ());if ((Common::NXCore::ErrnoENOENT ()==$error)){
Common::NXMsg::error (
"\x65\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65\x4e\x6f\x74\x45\x78\x69\x73\x74"
,$sfile);return ((0x0044+ 7704-0x1e5c));}else{Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65"
,$sfile);return ((0x1c0b+ 1112-0x2063));}}else{while (main::nxreadLine ($KEY_FD,
(\$_))){($content.=$_);}main::nxclose ($KEY_FD);}(my (@tmp)=split ( /\n/ ,
$content,(0x09cf+ 4593-0x1bc0)));(my (@licencje)=convertToArray (@tmp));(my (
@parsed_licenses)=convertArrayToLicArray (@licencje));if (($#parsed_licenses==(-
(0x0885+ 440-0x0a3c)))){Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x41\x64\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65"
,$sfile);Common::NXMsg::error (
"\x65\x49\x6e\x76\x61\x6c\x69\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e"
);return ((0x0306+ 2720-0x0da6));}(my $SUB_FD=main::nxopen (
$GLOBAL::PRODUCT_KEY_FILE,(($NXBits::O_WRONLY+$NXBits::O_APPEND)+
$NXBits::O_CREAT),(($NXBits::UserReadWrite+$NXBits::GroupRead)+
$NXBits::OthersRead)));if ((not (defined ($SUB_FD)))){(my $errorString=
libnxh::NXGetErrorString ());Common::NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x4f\x70\x65\x6e\x4c\x69\x63\x65\x6e\x73\x65\x46\x69\x6c\x65"
,$errorString);return ((0x0602+ 4130-0x1624));}main::nxwrite ($SUB_FD,$content);
main::nxclose ($SUB_FD);Common::NXMsg::send_response (
"\x69\x41\x64\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65\x31"
,$sfile);Common::NXMsg::send_response (
"\x69\x41\x64\x64\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x46\x69\x6c\x65\x32"
);return ((0x0c8d+ 1675-0x1318));}sub serverlist{(my (@licenseFile)=
load_license_from_file ());(my (@licencje)=convertToArray (@licenseFile));(my (
@parsed_licenses)=convertArrayToLicArray (@licencje));(my $flag_found_any_license
=(0x0176+ 4949-0x14cb));if (($#parsed_licenses==(-(0x0725+ 686-0x09d2)))){
Common::NXMsg::error (
"\x77\x42\x72\x61\x6e\x64\x4d\x65\x73\x73\x61\x67\x65\x4c\x69\x63\x65\x6e\x63\x65\x4e\x6f\x74\x46\x6f\x75\x6e\x64"
);Common::NXMsg::error (
"\x65\x4e\x6f\x64\x65\x43\x61\x6e\x6e\x6f\x74\x50\x65\x72\x66\x6f\x72\x6d\x4f\x70\x65\x72\x61\x74\x69\x6f\x6e"
);main::nxexit ((0x1612+ 854-0x1967));}foreach my $lic (@parsed_licenses){if ((
defined ($$lic{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"})and $$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"})){($flag_found_any_license=
(0x11c8+ 236-0x12b3));Common::NXMsg::send_response (
"\x69\x53\x65\x72\x76\x65\x72\x4b\x65\x79",$$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"});($GLOBAL::NODE_ROOT=
$GLOBAL::NX_SYSTEM);(my $keyfile=((((((($GLOBAL::NODE_ROOT.
$GLOBAL::DIRECTORY_SLASH)."\x65\x74\x63").$GLOBAL::DIRECTORY_SLASH).
"\x6b\x65\x79\x73").$GLOBAL::DIRECTORY_SLASH).$$lic{
"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"}).
"\x2e\x6e\x6f\x64\x65\x2e\x69\x64\x5f\x64\x73\x61\x2e\x70\x75\x62"));if (
Common::NXFile::fileExists ($keyfile)){Common::NXMsg::send_response (
"\x69\x55\x73\x69\x6e\x67\x4b\x65\x79",$keyfile);}else{Common::NXMsg::error (
"\x65\x4e\x6f\x74\x48\x61\x76\x69\x6e\x67\x56\x61\x6c\x69\x64\x4b\x65\x79",$$lic
{"\x73\x65\x72\x76\x65\x72\x5f\x6b\x65\x79"});}}}if (($flag_found_any_license==
(0x069b+ 1987-0x0e5e))){Common::NXMsg::error (
"\x65\x4e\x6f\x53\x65\x72\x76\x65\x72\x41\x73\x73\x6f\x63\x69\x61\x74\x65\x64");
}return;}return ((0x0268+ 3012-0x0e2b));
